﻿Imports System.Runtime.CompilerServices
Imports System.Drawing
Imports System.Reflection

Namespace System.Windows.Forms

   Public Module ControlX

      <Extension()> _
      Public Sub SetDoubleBuffer(ByVal subj As Control, ByVal value As Boolean)
         Dim inf = GetType(Control).GetProperty("DoubleBuffered", BindingFlags.Instance Or BindingFlags.NonPublic)
         inf.SetValue(subj, value, Nothing)
      End Sub

      ''' <summary>
      ''' korrigiere Control.Invalidate() - Fehldesign: Bei Rectangle.Empty wird nämlich das ganze Control invalidiert
      ''' </summary>
      <Extension()> _
      Public Sub InvalidateX(ByVal subj As Control, ByVal rct As Rectangle)
         If rct.Width = 0 OrElse rct.Height = 0 Then Return
         subj.Invalidate(rct)
      End Sub

      <Extension()> _
      Public Sub StartUpAt(ByVal subj As Form, ByVal Align As ContentAlignment)
         subj.StartPosition = FormStartPosition.Manual
         Dim rct = Screen.PrimaryScreen.WorkingArea
         With rct
            Select Case Align
               Case ContentAlignment.BottomCenter
                  .Y = .Bottom - subj.Height
                  .Height = subj.Height
               Case ContentAlignment.BottomLeft
                  .Y = .Bottom - subj.Height
                  .Size = subj.Size
               Case ContentAlignment.BottomRight
                  .Y = .Bottom - subj.Height
                  .X = .Right - subj.Width
                  .Size = subj.Size
               Case ContentAlignment.MiddleCenter
                  subj.StartPosition = FormStartPosition.CenterScreen
                  Return
               Case ContentAlignment.MiddleLeft
                  .Y = (.Bottom - subj.Height) \ 2
                  .Size = subj.Size
               Case ContentAlignment.MiddleRight
                  .Y = (.Bottom - subj.Height) \ 2
                  .X = .Right - subj.Width
                  .Size = subj.Size
               Case ContentAlignment.TopCenter
                  .Height = subj.Height
               Case ContentAlignment.TopLeft
                  .Size = subj.Size
               Case ContentAlignment.TopRight
                  .X = .Right - subj.Width
                  .Size = subj.Size
            End Select
         End With
         subj.Bounds = rct
      End Sub

      <Extension()> _
      Public Function BoundsToScreen(ByVal subj As Control) As Rectangle
         Return subj.RectangleToScreen(subj.ClientRectangle)
      End Function

      <Extension()> _
      Public Sub Remove(ByVal Subj As System.Windows.Forms.ControlBindingsCollection, ByVal name As String)
         Subj.Remove(Subj(name))
      End Sub

   End Module

End Namespace 'System.Windows.Forms

