﻿Imports System.Collections.Generic

Namespace System

   ''' <summary>
   ''' eingegeben werden Separatoren eines Zahlenbereiches, zusammen mit Items. Die Items matchen dann auf alle Werte von (einschließlich) diesem Separator bis zum nächsthöheren. Das Smallest-Item muß logischerweise ohne Separator eingegeben werden. Die Klasse kann auch als Mini-Dictionary herhalten. Flow-Interface-Initialisierung
   ''' </summary>
   Public Class RangeSelector(Of TKey As IComparable, TValue)

      Private _Keys As New List(Of TKey)
      Private _Values As New List(Of TValue)

      Protected Sub New(ByVal smallest As TValue)
         _Values.Add(smallest)
      End Sub

      Public Shared Function Create(ByVal smallest As TValue) As RangeSelectorIniter
         Return New RangeSelectorIniter(smallest)
      End Function

      ''' <summary> item will be associated with Values >= separator</summary>
      Public Function Add(ByVal separator As TKey, ByVal item As TValue) As RangeSelector(Of TKey, TValue)
         Dim i = _Keys.BinarySearch(separator)
         If i < 0 Then i = i Xor -1
         _Keys.Insert(i, separator)
         _Values.Insert(i + 1, item)
         Return Me
      End Function

      Default Public ReadOnly Property Item(ByVal key As TKey) As TValue
         Get
            Dim i = _Keys.BinarySearch(key)
            Return _Values(If(i < 0, i Xor -1, i + 1))
         End Get
      End Property

      Public Class RangeSelectorIniter : Inherits RangeSelector(Of TKey, TValue)
         Public Sub New(ByVal smallest As TValue)
            MyBase.New(smallest)
         End Sub
         ''' <summary> item will be associated with Values >= separator</summary>
         Default Public Shadows ReadOnly Property AddFlow(ByVal separator As TKey, ByVal item As TValue) As RangeSelectorIniter
            Get
               MyBase.Add(separator, item)
               Return Me
            End Get
         End Property
      End Class

   End Class
End Namespace